#include <irrlicht.h>
#include <iostream>
#include <list>

using namespace irr;

#pragma comment(lib, "Irrlicht.lib")

class character
{
public:
	int x,y;
	int imageNumber;
	character(int getx, int gety)
	{
		x=getx;
		y=gety;
		imageNumber=0;
	};
};

std::list<character*> bullet;
std::list<character*>::iterator bulletP;

std::list<character*> enemy;
std::list<character*>::iterator enemyP;

std::list<character*> enemyBullet;
std::list<character*>::iterator enemyBulletP;

std::list<character*> smoke;
std::list<character*>::iterator smokeP;

static int jikix=320, jikiy=240;

static bool left=false, right=false, up=false, down=false;
static bool button1=false, canFire=true;

class MyEventReceiver : public IEventReceiver
{
public:
	virtual bool OnEvent(SEvent event)
	{
		if (event.EventType == irr::EET_KEY_INPUT_EVENT)
		{
			if (event.KeyInput.PressedDown)
			{
				switch(event.KeyInput.Key)
				{
				case KEY_ESCAPE:
					exit(0);

				case KEY_LEFT:
					left = true;
					return true;

				case KEY_RIGHT:
					right=true;
					return true;

				case KEY_UP:
					up=true;
					return true;

				case KEY_DOWN:
					down=true;
					return true;

				case KEY_KEY_Z:
					button1=true;
					return true;
				}
			}
			else
			{
				switch(event.KeyInput.Key)
				{
				case KEY_LEFT:
					left = false;
					return true;

				case KEY_RIGHT:
					right = false;
					return true;

				case KEY_UP:
					up = false;
					return true;

				case KEY_DOWN:
					down = false;
					return true;
				case KEY_KEY_Z:
					button1=false;
					canFire=true;
					return true;
				}
			}
		}

		return false;
	}
};

int main()
{
	MyEventReceiver receiver;

	video::E_DRIVER_TYPE driverType;

	driverType = video::EDT_SOFTWARE;

	IrrlichtDevice *device = createDevice(driverType,
		core::dimension2d<s32>(640, 480), 16,false,false,false,&receiver);

	if (device == 0)
		return 1;

	device->setWindowCaption(L"iKIwKX gamedev@2ch");

	video::IVideoDriver* driver = device->getVideoDriver();

	video::ITexture* images = driver->getTexture("all256.bmp");
	driver->makeColorKeyTexture(images, core::position2d<s32>(0,0));

	video::ITexture* imagesLogo = driver->getTexture("gamdev.bmp");

	//tHgݒ
	gui::IGUIFont* font = device->getGUIEnvironment()->getBuiltInFont();

	//\摜̐ݒ
	core::rect<s32> jiki1(0,24,15,39);
	core::rect<s32> jiki2(0,40,15,55);
	core::rect<s32> teki(16,72,31,88);
	core::rect<s32> Logo(0,0,449,119);
	core::rect<s32> tama(16,24,31,39);
	core::rect<s32> etama(0,312,8,319);
	core::rect<s32> smokexy0(0,120+(0*32),32,152+(0*32));
	core::rect<s32> smokexy1(0,120+(1*32),32,152+(1*32));
	core::rect<s32> smokexy2(0,120+(2*32),32,152+(2*32));
	core::rect<s32> smokexy3(0,120+(3*32),32,152+(3*32));
	core::rect<s32> smokexy4(0,120+(4*32),32,152+(4*32));
	core::rect<s32> smokexy5(0,120+(5*32),32,152+(5*32));

	//C[v
	while(device->run() && driver)
	{
		if (device->isWindowActive())
		{
			u32 time = device->getTimer()->getTime();

			driver->beginScene(true, true, video::SColor(0,120,102,136));

			// L[씽f
			if (left && jikix > 0)
				jikix--;
			if (right && jikix < 639-16)
				jikix++;
			if (up && jikiy > 0)
				jikiy--;
			if (down && jikiy <479-16)
				jikiy++;

			//e
			if (button1 && canFire)
			{
				bullet.push_back(new character(jikix,jikiy) );
				canFire=false;
			}


			//eړ
			for (bulletP = bullet.begin() ; bulletP != bullet.end() ; bulletP++)
			{
				(*bulletP)->y-=4;
				if ( (*bulletP)->y < 0 )
				{
					delete(*bulletP);
					bulletP=bullet.erase(bulletP);
				}
			}

			//@eƓG̓蔻
			for (bulletP = bullet.begin() ; bulletP != bullet.end() ; bulletP++)
			{
				bool isKill; //eȂɂɓ
				isKill=false;
				//Gړ
				for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
				{
					if ( abs( (*bulletP)->x - (*enemyP)->x) < 16 &&
						abs( (*bulletP)->y - (*enemyP)->y) < 16 )
					{
						smoke.push_back(new character( (*enemyP)->x-8, (*enemyP)->y-8) );
						delete(*enemyP);
						enemyP=enemy.erase(enemyP);
						isKill=true;
					}
				}

				if ( isKill==true )
				{
					delete(*bulletP);
					bulletP=bullet.erase(bulletP);
				}
			}

			//G
			static int SpawnCount=100;
			if (--SpawnCount == 0)
			{
				enemy.push_back(new character(jikix,0) );
				SpawnCount=100;
			}

			//Gړ
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				(*enemyP)->y++;
				if ( (*enemyP)->y >479)
				{
					delete(*enemyP);
					enemyP=enemy.erase(enemyP);
				}
			}

			//GƎ@̓蔻
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				if ( abs( jikix - (*enemyP)->x) < 8 &&
					abs( jikiy - (*enemyP)->y) < 8 )

				smoke.push_back(new character( jikix-8, jikiy-8) );
			}

			//Ge
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				static int enemyBulletSpawnCount=133;
				if (--enemyBulletSpawnCount == 0)
				{
					enemyBullet.push_back(new character( (*enemyP)->x+4,(*enemyP)->y+4) );
					enemyBulletSpawnCount=133;
				}
			}

			//Geړ
			for (enemyBulletP = enemyBullet.begin() ; enemyBulletP != enemyBullet.end() ; enemyBulletP++)
			{
				(*enemyBulletP)->y+=4;
				if ( (*enemyBulletP)->y >479)
				{
					delete(*enemyBulletP);
					enemyBulletP=enemyBullet.erase(enemyBulletP);
				}
			}

			//GeƎ@̓蔻
			for (enemyBulletP = enemyBullet.begin() ; enemyBulletP != enemyBullet.end() ; enemyBulletP++)
			{
				if ( abs( jikix - (*enemyBulletP)->x) < 8 &&
					abs( jikiy - (*enemyBulletP)->y) < 8 )

				smoke.push_back(new character( jikix-8, jikiy-8) );
			}

			//S\
			driver->draw2DImage(imagesLogo, core::position2d<s32>(0,0),
				Logo, 0, 
				video::SColor(255,255,255,255), true);

			// @`
			driver->draw2DImage(images, core::position2d<s32>(jikix,jikiy),
				(time/500 % 2) ? jiki1 : jiki2, 0, 
				video::SColor(255,255,255,255), true);

			//e`
			for (bulletP = bullet.begin() ; bulletP != bullet.end() ; bulletP++)
			{
				driver->draw2DImage(images, core::position2d<s32>((*bulletP)->x,(*bulletP)->y),
					tama , 0, 
					video::SColor(255,255,255,255), true);
			}

			//G`
			for (enemyP = enemy.begin() ; enemyP != enemy.end() ; enemyP++)
			{
				driver->draw2DImage(images, core::position2d<s32>((*enemyP)->x,(*enemyP)->y),
					teki , 0, 
					video::SColor(255,255,255,255), true);
			}

			//Ge`
			for (enemyBulletP = enemyBullet.begin() ; enemyBulletP != enemyBullet.end() ; enemyBulletP++)
			{
				driver->draw2DImage(images, core::position2d<s32>((*enemyBulletP)->x,(*enemyBulletP)->y),
					etama , 0, 
					video::SColor(255,255,255,255), true);
			}

			//`
			for (smokeP = smoke.begin() ; smokeP != smoke.end() ; smokeP++)
			{
				switch ((*smokeP)->imageNumber++)
				{
				case 0:
					driver->draw2DImage(images, core::position2d<s32>((*smokeP)->x,(*smokeP)->y),smokexy0 , 0,video::SColor(255,255,255,255), true);
					break;
				case 1:
					driver->draw2DImage(images, core::position2d<s32>((*smokeP)->x,(*smokeP)->y),smokexy1 , 0,video::SColor(255,255,255,255), true);
					break;
				case 2:
					driver->draw2DImage(images, core::position2d<s32>((*smokeP)->x,(*smokeP)->y),smokexy2 , 0,video::SColor(255,255,255,255), true);
					break;
				case 3:
					driver->draw2DImage(images, core::position2d<s32>((*smokeP)->x,(*smokeP)->y),smokexy3 , 0,video::SColor(255,255,255,255), true);
					break;
				case 4:
					driver->draw2DImage(images, core::position2d<s32>((*smokeP)->x,(*smokeP)->y),smokexy4 , 0,video::SColor(255,255,255,255), true);
					break;
				case 5:
					driver->draw2DImage(images, core::position2d<s32>((*smokeP)->x,(*smokeP)->y),smokexy5 , 0,video::SColor(255,255,255,255), true);
					break;
				case 6:
					delete(*smokeP);
					smokeP=smoke.erase(smokeP);
					break;
				}
			}

			// eLXg\
			if (font)
			font->draw(L"gamedev@2ch", 
				core::rect<s32>(580,470,640,480),
				video::SColor(255,255,255,255));


			driver->endScene();
		}
	}

	device->drop();

	return 0;
}
